const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ObrasDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const obras = await db.obras.create(
      {
        id: data.id || undefined,

        nome_obra: data.nome_obra || null,
        cidade: data.cidade || null,
        estado: data.estado || null,
        descricao: data.descricao || null,
        data_inicio: data.data_inicio || null,
        data_previsao_termino: data.data_previsao_termino || null,
        plantas_2d_georreferenciadas:
          data.plantas_2d_georreferenciadas || false,

        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await obras.setCliente(data.cliente || null, {
      transaction,
    });

    await obras.setClientes(data.clientes || null, {
      transaction,
    });

    return obras;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const obrasData = data.map((item, index) => ({
      id: item.id || undefined,

      nome_obra: item.nome_obra || null,
      cidade: item.cidade || null,
      estado: item.estado || null,
      descricao: item.descricao || null,
      data_inicio: item.data_inicio || null,
      data_previsao_termino: item.data_previsao_termino || null,
      plantas_2d_georreferenciadas: item.plantas_2d_georreferenciadas || false,

      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const obras = await db.obras.bulkCreate(obrasData, { transaction });

    // For each item created, replace relation files

    return obras;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const obras = await db.obras.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.nome_obra !== undefined) updatePayload.nome_obra = data.nome_obra;

    if (data.cidade !== undefined) updatePayload.cidade = data.cidade;

    if (data.estado !== undefined) updatePayload.estado = data.estado;

    if (data.descricao !== undefined) updatePayload.descricao = data.descricao;

    if (data.data_inicio !== undefined)
      updatePayload.data_inicio = data.data_inicio;

    if (data.data_previsao_termino !== undefined)
      updatePayload.data_previsao_termino = data.data_previsao_termino;

    if (data.plantas_2d_georreferenciadas !== undefined)
      updatePayload.plantas_2d_georreferenciadas =
        data.plantas_2d_georreferenciadas;

    updatePayload.updatedById = currentUser.id;

    await obras.update(updatePayload, { transaction });

    if (data.cliente !== undefined) {
      await obras.setCliente(
        data.cliente,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await obras.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return obras;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const obras = await db.obras.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of obras) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of obras) {
        await record.destroy({ transaction });
      }
    });

    return obras;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const obras = await db.obras.findByPk(id, options);

    await obras.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await obras.destroy({
      transaction,
    });

    return obras;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const obras = await db.obras.findOne({ where }, { transaction });

    if (!obras) {
      return obras;
    }

    const output = obras.get({ plain: true });

    output.cameras_ptz_obra = await obras.getCameras_ptz_obra({
      transaction,
    });

    output.equipes_trabalho_obra = await obras.getEquipes_trabalho_obra({
      transaction,
    });

    output.estrutura_projeto_obra = await obras.getEstrutura_projeto_obra({
      transaction,
    });

    output.etapas_ou_trechos_obra = await obras.getEtapas_ou_trechos_obra({
      transaction,
    });

    output.inspecao_aerea_obra = await obras.getInspecao_aerea_obra({
      transaction,
    });

    output.memoriais_descritivos_asbuilt_obra =
      await obras.getMemoriais_descritivos_asbuilt_obra({
        transaction,
      });

    output.modelos_bim_asbuilt_obra = await obras.getModelos_bim_asbuilt_obra({
      transaction,
    });

    output.plantas_asbuilt_2d_obra = await obras.getPlantas_asbuilt_2d_obra({
      transaction,
    });

    output.relatorio_andamento_atual_obra =
      await obras.getRelatorio_andamento_atual_obra({
        transaction,
      });

    output.relatorios_diarios_obra = await obras.getRelatorios_diarios_obra({
      transaction,
    });

    output.relatorios_mensais_obra = await obras.getRelatorios_mensais_obra({
      transaction,
    });

    output.relatorios_semanais_obra = await obras.getRelatorios_semanais_obra({
      transaction,
    });

    output.cliente = await obras.getCliente({
      transaction,
    });

    output.clientes = await obras.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.clientes,
        as: 'cliente',
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.nome_obra) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('obras', 'nome_obra', filter.nome_obra),
        };
      }

      if (filter.cidade) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('obras', 'cidade', filter.cidade),
        };
      }

      if (filter.estado) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('obras', 'estado', filter.estado),
        };
      }

      if (filter.descricao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('obras', 'descricao', filter.descricao),
        };
      }

      if (filter.calendarStart && filter.calendarEnd) {
        where = {
          ...where,
          [Op.or]: [
            {
              data_inicio: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
            {
              data_previsao_termino: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
          ],
        };
      }

      if (filter.data_inicioRange) {
        const [start, end] = filter.data_inicioRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            data_inicio: {
              ...where.data_inicio,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            data_inicio: {
              ...where.data_inicio,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.data_previsao_terminoRange) {
        const [start, end] = filter.data_previsao_terminoRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            data_previsao_termino: {
              ...where.data_previsao_termino,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            data_previsao_termino: {
              ...where.data_previsao_termino,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.plantas_2d_georreferenciadas) {
        where = {
          ...where,
          plantas_2d_georreferenciadas: filter.plantas_2d_georreferenciadas,
        };
      }

      if (filter.cliente) {
        const listItems = filter.cliente.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clienteId: { [Op.or]: listItems },
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.obras.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('obras', 'nome_obra', query),
        ],
      };
    }

    const records = await db.obras.findAll({
      attributes: ['id', 'nome_obra'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['nome_obra', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.nome_obra,
    }));
  }
};
